/*
 * mvme.S -- board support for m68k
 */

	.title "mvme.S for m68k-coff"

/* These are predefined by new versions of GNU cpp.  */

#ifndef __USER_LABEL_PREFIX__
#define __USER_LABEL_PREFIX__ _
#endif

#ifndef __REGISTER_PREFIX__
#define __REGISTER_PREFIX__
#endif

/* ANSI concatenation macros.  */

#define CONCAT1(a, b) CONCAT2(a, b)
#define CONCAT2(a, b) a ## b

/* Use the right prefix for global labels.  */

#define SYM(x) CONCAT1 (__USER_LABEL_PREFIX__, x)

/* Use the right prefix for registers.  */

#define REG(x) CONCAT1 (__REGISTER_PREFIX__, x)

#define d0 REG (d0)
#define d1 REG (d1)
#define d2 REG (d2)
#define d3 REG (d3)
#define d4 REG (d4)
#define d5 REG (d5)
#define d6 REG (d6)
#define d7 REG (d7)
#define a0 REG (a0)
#define a1 REG (a1)
#define a2 REG (a2)
#define a3 REG (a3)
#define a4 REG (a4)
#define a5 REG (a5)
#define a6 REG (a6)
#define fp REG (fp)
#define sp REG (sp)
#define vbr REG (vbr)

	.align	2
	.text
	.global SYM (_exit)
	.global SYM (outln)
	.global SYM (outbyte)
	.global SYM (putDebugChar)
	.global SYM (inbyte)
	.global SYM (getDebugChar)
	.global SYM (havebyte)
	.global SYM (exceptionHandler)

	.set	vbr_size, 0x400
	.comm	SYM (vbr_table), vbr_size

/*
 * setup_vectors -- creates a new exception vector table and
 *		    populates it. Vectors from the boot monitor
 *		    are spliced in so I/O and the abort button
 *		    will continue to work. We also use the monitor's
 *		    generalized vector for anything the debugger
 *		    doesn't want.
 */
	.global	SYM (setup_vectors)
SYM (setup_vectors):
	link	fp, #-8
	/* copy monitor vector table */
	movecl	vbr, a0
	lea	SYM (vbr_table), a1
	movel	0x8(a0), d0		/* get generalized vector */
	movew	#0x3fc, d1		/* load vector count */
loop:					/* fill table to gen. vector */
	movel	d0, (a1,d1)
	subqw	#4, d1
	bne	loop

	movel	0x10(a0), 0x10(a1) /* breakpoint */
	movel	0x24(a0), 0x24(a1) /* trace */
	movel	0xbc(a0), 0xbc(a1) /* system call */

        /* add stub vectors to table */
        movel	#SYM (_catchException), 0x8(a1)  /* vector = 2,  Access Fault */
        movel	#SYM (_catchException), 0xc(a1)  /* vector = 3,  Address Error */
        movel   #SYM (_catchException), 0x10(a1) /* vector = 4,  Illegal instruction */
        movel   #SYM (_catchException), 0x14(a1) /* vector = 5,  divide by 0 */
        movel   #SYM (_catchException), 0x18(a1) /* vector = 6,  chk, chk2 instruction */
        movel   #SYM (_catchException), 0x1c(a1) /* vector = 7,  ftrap, trap, trapv ins */
        movel   #SYM (_catchException), 0x20(a1) /* vector = 8,  priviledge violation */
        movel   #SYM (_catchException), 0x24(a1) /* vector = 9,  trace */
        movel   #SYM (_catchException), 0x28(a1) /* vector = 10, Aline opcode */
        movel   #SYM (_catchException), 0x2c(a1) /* vector = 11, fline opcode */
        movel   #SYM (_catchException), 0x30(a1) /* vector = 12, reserved */
        movel   #SYM (_catchException), 0x34(a1) /* vector = 13, coprocessor protocol violation */
        movel   #SYM (_catchException), 0x38(a1) /* vector = 14, format error */
        movel   #SYM (_catchException), 0x3c(a1) /* vector = 15, unitialized interupt */
        
        /* unassigned, reserved */
        movel   #SYM (_catchException), 0x40(a1) /* vector = 16 */
        movel   #SYM (_catchException), 0x44(a1) /* vector = 17 */
        movel   #SYM (_catchException), 0x48(a1) /* vector = 18 */
        movel   #SYM (_catchException), 0x4c(a1) /* vector = 19 */
        movel   #SYM (_catchException), 0x50(a1) /* vector = 20 */
        movel   #SYM (_catchException), 0x54(a1) /* vector = 21 */
        movel   #SYM (_catchException), 0x58(a1) /* vector = 22 */
        movel   #SYM (_catchException), 0x5c(a1) /* vector = 23 */

        movel   #SYM (_catchException), 0x84(a1) /* vector = 33, breakpoint, trap #1 */
        movel   #SYM (_catchException), 0xa0(a1) /* vector = 40 , trap #8*/

        /* floating point traps */
        movel   #SYM (_catchException), 0xc0(a1) /* vector = 48 */
        movel   #SYM (_catchException), 0xc4(a1) /* vector = 49 */
        movel   #SYM (_catchException), 0xc8(a1) /* vector = 50 */
        movel   #SYM (_catchException), 0xcc(a1) /* vector = 51 */
        movel   #SYM (_catchException), 0xd0(a1) /* vector = 52 */
        movel   #SYM (_catchException), 0xd4(a1) /* vector = 53 */
        movel   #SYM (_catchException), 0xd8(a1) /* vector = 54 */
        movel   #SYM (_catchException), 0xdc(a1) /* vector = 55 */
        movel   #SYM (_catchException), 0xe0(a1) /* vector = 56 */
        movel   #SYM (_catchException), 0xe4(a1) /* vector = 57 */
        movel   #SYM (_catchException), 0xe8(a1) /* vector = 58 */

/***        movel   #__debug_level7, 0x7c(a1) /* level7 interupt vector */

	movecl	a1, vbr		/* change VBR to new table */        

	unlk	fp
	rts
/*
 * exceptionHandler -- sets up exception vector table.
 *		       First arg is an integer vector number
 *		       Second arg is the function pointer for the vector
 */
SYM (exceptionHandler):
#	link	a6, #-8
#str1:	.ascii	"Exception Handler Called\n"
#	moveal	#str1, a0
#	moveal	#str1+25, a1
#	jsr	SYM (outln)

#	unlk	a6
	rts

/* this never gets called */
 	movel	fp@(8), d0		/* get vector number */
	movel	fp@(12), a0		/* get function address */
	moveal	#SYM (vbr_table), a1	/* FIXME */

	addl	d0, d0
	addl	d0, d0

	addal	d0, a1
	movel	a0, (a1)

	movecl	a1, vbr
	unlk	a6
	rts

/*
 * exit -- exits back to boot monitor
 */
SYM (_exit):
	unlk	a6
	trap #15
	.word return

	.align	2

/*
 * inbyte -- get a byte from the serial port
 *	d0 - contains the byte read in
 */
	.align	2
SYM (getDebugChar):		/* symbol name used by m68k-stub */
SYM (inbyte):
	link	a6, #-8
	trap 	#15
	.word	inchr
	moveb 	sp@, d0
	extbl	d0
	unlk	a6
	rts

/*
 * outbyte -- sends a byte out the serial port
 *	d0 - contains the byte to be sent
 */
	.align	2
SYM (putDebugChar):		/* symbol name used by m68k-stub */
SYM (outbyte):
	link	fp, #-4
 	moveb	fp@(11), sp@
	trap 	#15
	.word	outchr
	unlk	fp
	rts

/*
 * outln -- sends a string of bytes out the serial port with a CR/LF
 *	a0 - contains the address of the string's first byte
 *	a1 - contains the address of the string's last byte
 */
	.align	2
SYM (outln):
	link	a6, #-8
	moveml	a0/a1, sp@
	trap 	#15
	.word 	outln
	unlk	a6
	rts

/*
 * outstr -- sends a string of bytes out the serial port without a CR/LF
 *	a0 - contains the address of the string's first byte
 *	a1 - contains the address of the string's last byte
 */
	.align	2
SYM (outstr):
	link	a6, #-8
	moveml	a0/a1, sp@
	trap 	#15
	.word 	outstr
	unlk	a6
	rts

/*
 * havebyte -- checks to see if there is a byte in the serial port,
 *             returns 1 if there is a byte, 0 otherwise.
 */
SYM (havebyte):
	trap 	#15
	.word	instat
	beqs	empty
	movel 	#1, d0
	rts
empty:
	movel	#0, d0
	rts

/*
 * These constants are for the MVME-135 board's boot monitor. They
 * are used with a TRAP #15 call to access the monitor's I/O routines.
 * they must be in the word following the trap call.
 */
	.set inchr, 0x0
	.set instat, 0x1
	.set inln, 0x2
	.set readstr, 0x3
	.set readln, 0x4
	.set chkbrk, 0x5

	.set outchr, 0x20
	.set outstr, 0x21
	.set outln, 0x22
	.set write, 0x23
	.set writeln, 0x24
	.set writeln, 0x25
	.set pcrlf, 0x26
	.set eraseln, 0x27
	.set writd, 0x28
	.set sndbrk, 0x29

	.set tm_ini, 0x40
	.set dt_ini, 0x42
	.set tm_disp, 0x43
	.set tm_rd, 0x44

	.set redir, 0x60
	.set redir_i, 0x61
	.set redir_o, 0x62
	.set return, 0x63
	.set bindec, 0x64

	.set changev, 0x67
	.set strcmp, 0x68
	.set mulu32, 0x69
	.set divu32, 0x6A
	.set chk_sum, 0x6B
